--Bit of ROM to go in place of the 2K vector RAM. This allows taking a snapshot of the
--vector RAM in e.g. Mame and then feeding it to the VHDL AVG. This way, the AVG
--can tested without the 6502 working at all: just make sure the AVG keeps running by
--e.g. tying the vggo line high.

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

library UNISIM;
use UNISIM.VComponents.all;

use work.pkg_bwidow.all;


entity vecram_filled is
    Port ( addr : in  STD_LOGIC_VECTOR (10 downto 0);
           data_in : in  STD_LOGIC_VECTOR (7 downto 0);
           data_out : out  STD_LOGIC_VECTOR (7 downto 0);
           rw_l : in  STD_LOGIC;
           cs_l : in  STD_LOGIC;
           ena : in  STD_LOGIC;
           clk : in  STD_LOGIC);
end vecram_filled;

architecture Behavioral of vecram_filled is
component rom_avgstate is
  port (
    CLK         : in    std_logic;
    ADDR        : in    std_logic_vector(10 downto 0);
    DATA        : out   std_logic_vector(7 downto 0)
    );
end component;

	signal we:		STD_LOGIC;
begin
	vecram_rom: rom_avgstate port map (
		CLK => clk,
		ADDR => addr,
		DATA => data_out
	);
end Behavioral;

