--The program ROM.

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

use work.pkg_bwidow.all;

entity pgmrom is
    Port ( addr : in  STD_LOGIC_VECTOR (14 downto 0);
           data : out  STD_LOGIC_VECTOR (7 downto 0);
           clk : in  STD_LOGIC);
end pgmrom;

architecture Behavioral of pgmrom is
	signal dataa: 		std_logic_vector(7 downto 0);
	signal datab: 		std_logic_vector(7 downto 0);
	signal datac: 		std_logic_vector(7 downto 0);
	signal datad: 		std_logic_vector(7 downto 0);
	signal datae: 		std_logic_vector(7 downto 0);
	signal dataf: 		std_logic_vector(7 downto 0);
--	signal datag: 		std_logic_vector(7 downto 0);
begin
	roma: rom_pgma port map (
		CLK => clk,
		ADDR => addr(11 downto 0),
		DATA => dataa
	);
	romb: rom_pgmb port map (
		CLK => clk,
		ADDR => addr(11 downto 0),
		DATA => datab
	);
	romc: rom_pgmc port map (
		CLK => clk,
		ADDR => addr(11 downto 0),
		DATA => datac
	);
	romd: rom_pgmd port map (
		CLK => clk,
		ADDR => addr(11 downto 0),
		DATA => datad
	);
	rome: rom_pgme port map (
		CLK => clk,
		ADDR => addr(11 downto 0),
		DATA => datae
	);
	romf: rom_pgmf port map (
		CLK => clk,
		ADDR => addr(11 downto 0),
		DATA => dataf
	);

	data <=	dataa when addr(14 downto 12)="001" else 
				datab when addr(14 downto 12)="010" else 
				datac when addr(14 downto 12)="011" else 
				datad when addr(14 downto 12)="100" else 
				datae when addr(14 downto 12)="101" else 
				dataf when addr(14 downto 12)="110" else 
				dataf when addr(14 downto 12)="111" --last rom is mirrored once
				else "00000000";
end Behavioral;

