--Vector rom. Warning: roma is smaller and mirrored once.

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

use work.pkg_bwidow.all;

entity vecrom is
    Port ( addr : in  STD_LOGIC_VECTOR (13 downto 0);
           data : out  STD_LOGIC_VECTOR (7 downto 0);
           clk : in  STD_LOGIC);
end vecrom;

architecture Behavioral of vecrom is
	signal dataa: 		std_logic_vector(7 downto 0);
	signal datab: 		std_logic_vector(7 downto 0);
	signal datac: 		std_logic_vector(7 downto 0);
	signal datad: 		std_logic_vector(7 downto 0);
begin
	roma: rom_veca port map (
		CLK => clk,
		ADDR => addr(10 downto 0),
		DATA => dataa
	);
	romb: rom_vecb port map (
		CLK => clk,
		ADDR => addr(11 downto 0),
		DATA => datab
	);
	romc: rom_vecc port map (
		CLK => clk,
		ADDR => addr(11 downto 0),
		DATA => datac
	);
	romd: rom_vecd port map (
		CLK => clk,
		ADDR => addr(11 downto 0),
		DATA => datad
	);

--Watch the weird inversion of romd and romb!
	data <=	dataa	when addr(13 downto 12)="00" else  --Mirrors once.
				datab when addr(13 downto 12)="01" else 
				datac when addr(13 downto 12)="10" else 
				datad when addr(13 downto 12)="11"
				else "00000000";
end Behavioral;

