#!/usr/bin/php
<?

$mem=file_get_contents("vrom.bin");
$pc=0;
$im=imagecreatetruecolor(1024, 1024);
$sp=0;
$stack=array(0,0,0,0);


imagecolorallocate($im, 0,0,0); //black

$cx=512; $cy=512;
$col=0; $intens=0;
$scale=1;
while(1) {
	$ins=ord($mem[$pc*2]);
	$ins|=ord($mem[$pc*2+1])<<8;
//	if ($pc>1024) $ins=0xC000;
	$pc++;
	if (($ins>>13)==0 || (($ins>>13)==2)) { //draw rel vect / draw short
		if (($ins>>13)==0) {
			$op=ord($mem[$pc*2]);
			$op|=ord($mem[$pc*2+1])<<8;
			$pc++;

			$dy=$ins&0x1fff;
			$dx=$op&0x1fff;
			if ($dx&0x1000) $dx=($dx&0xFFF)-0x1000;
			if ($dy&0x1000) $dy=($dy&0xFFF)-0x1000;

			$intensmod=$op>>13;

//			echo "DRAW $dx $dy\n";
		} else {

			$dy=(($ins>>8)&0x1f);
			$dx=($ins&0x1F);
			$intensmod=($ins>>5)&0x7;
			printf("DS col $col: 0x%04b x=$dx y=$dy intens=$intensmod\n", $ins);

			if ($dy&0x10) $dy=($dy&0xf)-0x10;
			if ($dx&0x10) $dx=($dx&0xf)-0x10;
//			$dx-=16; $dy-=16;
			$dx*=2; $dy*=2;
//			$intensmod=0;
//			echo "DRAW SHORT $dx $dy\n";
		}
//		$real_intens=$intens*$intensmod; //0-16 * 0-16  = 0-255
		$real_intens=($intensmod==0)?0:255;
		$c=imagecolorallocate($im, ($col&4)?$real_intens:0, ($col&2)?$real_intens:0, ($col&1)?$real_intens:0);
		$dx=intval(($dx*$scale)/700);
		$dy=intval(($dy*$scale)/700);
		$dy=-$dy; //flip image
		if ($real_intens!=0) imageline($im, $cx, $cy, $cx+$dx, $cy+$dy, $c);
		echo "Drawing line, ($cx,$cy)-(".($cx+$dx).",".($cy+$dy).") col $col intens $real_intens scale $scale.\n";
		$cx+=$dx; $cy+=$dy;
	} else if (($ins>>13)==1) { //halt
		imagepng($im, "out.png");
		exit(0);
	} else if (($ins>>12)==6) { //new color
		$intens=($ins&0xF0)>>4;
		$col=$ins&0x7;
//		if ($col==0) $col=7;
	} else if (($ins>>12)==7) { //new scale
		$scale=0xff-($ins&0x0FF);
		$binsc=($ins>>8)&0x7;
		$scale*=pow(2, 1-$qbinsc);
//		$scale=($ins&0x01FF); //FOUT!
		printf("SCALE 0x%x\n",$ins);
	} else if (($ins>>13)==4) { //center
		$cx=512; $cy=512;
		echo "CENTER\n";
	} else if (($ins>>13)==5) { //jump subroutine
		$stack[$sp++]=$pc;
		$pc=($ins&0x1FFF);
	} else if (($ins>>13)==6) { //return
		$pc=$stack[--$sp];
	} else if (($ins>>13)==7) { //jump address
		$pc=($ins&0x1FFF);
	}
}



?>