----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:20:25 07/06/2011 
-- Design Name: 
-- Module Name:    filter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity filter is
	generic (
		mul: integer :=6;
		pole: integer := 63842);
    Port ( input : in  STD_LOGIC_VECTOR (9 downto 0);
           output : out  STD_LOGIC_VECTOR (9 downto 0);
			  reset: in STD_LOGIC;
           clk : in  STD_LOGIC);
end filter;

--Filter constants etc aquired from http://www-users.cs.york.ac.uk/~fisher/mkfilter
--1sd order Bessel hipass filter at 50KHz (when input clock is 12MHz) with 16.16 fixed point values.

architecture Behavioral of filter is

--constant mul0: STD_LOGIC_VECTOR(31 downto 0) := "00000000000000001111111010101001"; --5KHz
--constant mul0: STD_LOGIC_VECTOR(31 downto 0) := "00000000000000001111101010110001"; --20KHz
--constant mul0: STD_LOGIC_VECTOR(31 downto 0) := "00000000000000001111001011101111"; --50KHz
--constant mul0: STD_LOGIC_VECTOR(31 downto 0) := "00000000000000001101101010100101"; --150KHz
signal xv0: STD_LOGIC_VECTOR(31 downto 0);
signal xv1: STD_LOGIC_VECTOR(31 downto 0);
signal yv0: STD_LOGIC_VECTOR(31 downto 0);
signal yvmul0: STD_LOGIC_VECTOR(63 downto 0);
signal outval: STD_LOGIC_VECTOR(31 downto 0);
begin
filter: process(clk, reset)
begin
	if reset='1' then
		xv0<=(others=>'0');
		yv0<=(others=>'0');
	elsif rising_edge(clk) then
		xv0<=xv1;
		yv0<=(xv1-xv0)+yvmul0(47 downto 16);
		if (outval(26)='0') then
			output<=outval(25 downto 16);
		else
			if (outval(31)='1') then
				output<="0000000000";
			else
				output<="1111111111";
			end if;
		end if;
	end if;
end process;
yvmul0<=conv_std_logic_vector(pole,64)*sxt(yv0,64);
outval<=(yv0*conv_std_logic_vector(mul, 32))+xv1;
xv1<="000000"&input&"0000000000000000";
end Behavioral;

